/*###############################################################################
# Linux Management Providers (LMP), IP provider package
# Copyright (C) 2008 Guillaume BOTTEX, ETRI <guillaumebottex@etri.re.kr, guillaumebottex@gmail.com>
#
# This program is being developed under the "OpenDRIM" project.
# The "OpenDRIM" project web page: http://opendrim.sourceforge.net
# The "OpenDRIM" project mailing list: opendrim@googlegroups.com
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; version 2
# of the License.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
#################################################################################

#################################################################################
# To contributors, please leave your contact information in this section
# AND comment your changes in the source code.
#
# Modified by <Author(s)>, <Affiliation>, <Year>
###############################################################################*/

#ifndef OPENDRIM_GATEWAY2COMPUTERSYSTEMACCESS_H_
#define OPENDRIM_GATEWAY2COMPUTERSYSTEMACCESS_H_

#include "IP_Common.h"

#include "OpenDRIM_Gateway2ComputerSystem.h"
#include "assocOpenDRIM_Gateway2ComputerSystem.h"

int IP_OpenDRIM_Gateway2ComputerSystem_load(const CMPIBroker* broker, string& errorMessage);

int IP_OpenDRIM_Gateway2ComputerSystem_unload(string& errorMessage);

int IP_OpenDRIM_Gateway2ComputerSystem_retrieve(const CMPIBroker* broker, const CMPIContext* ctx, vector<OpenDRIM_Gateway2ComputerSystem>& instances, const char** properties, string& errorMessage, const string& discriminant);

int IP_OpenDRIM_Gateway2ComputerSystem_getInstance(const CMPIBroker* broker, const CMPIContext* ctx, OpenDRIM_Gateway2ComputerSystem& instance, const char** properties, string& errorMessage);

int IP_OpenDRIM_Gateway2ComputerSystem_setInstance(const CMPIBroker* broker, const CMPIContext* ctx, const OpenDRIM_Gateway2ComputerSystem& newInstance, const OpenDRIM_Gateway2ComputerSystem& oldInstance, const char** properties, string& errorMessage);

int IP_OpenDRIM_Gateway2ComputerSystem_createInstance(const CMPIBroker* broker, const CMPIContext* ctx, const OpenDRIM_Gateway2ComputerSystem& instance, string& errorMessage);

int IP_OpenDRIM_Gateway2ComputerSystem_deleteInstance(const CMPIBroker* broker, const CMPIContext* ctx, const OpenDRIM_Gateway2ComputerSystem& instance, string& errorMessage);

int IP_OpenDRIM_Gateway2ComputerSystem_associatorAntecedentToDependent(const CMPIBroker* broker, const CMPIContext* ctx, const Instance& Antecedent_instance, const char** properties, vector<Instance>& Dependent_associatedInstances, string& errorMessage, const string& discriminant);

int IP_OpenDRIM_Gateway2ComputerSystem_associatorDependentToAntecedent(const CMPIBroker* broker, const CMPIContext* ctx, const Instance& Dependent_instance, const char** properties, vector<Instance>& Antecedent_associatedInstances, string& errorMessage, const string& discriminant);

int IP_OpenDRIM_Gateway2ComputerSystem_referenceAntecedentToDependent(const CMPIBroker* broker, const CMPIContext* ctx, const Instance& Antecedent_instance, const vector<Instance>& Dependent_instances, vector<OpenDRIM_Gateway2ComputerSystem>& OpenDRIM_Gateway2ComputerSystem_instances, const char** properties, string& errorMessage, const string& discriminant);

int IP_OpenDRIM_Gateway2ComputerSystem_referenceDependentToAntecedent(const CMPIBroker* broker, const CMPIContext* ctx, const Instance& Dependent_instance, const vector<Instance>& Antecedent_instances, vector<OpenDRIM_Gateway2ComputerSystem>& OpenDRIM_Gateway2ComputerSystem_instances, const char** properties, string& errorMessage, const string& discriminant);

int IP_OpenDRIM_Gateway2ComputerSystem_populate(OpenDRIM_Gateway2ComputerSystem& instance, string& errorMessage);

#endif /*OPENDRIM_GATEWAY2COMPUTERSYSTEMACCESS_H_*/
