/*###############################################################################
# Linux Management Providers (LMP), IP provider package
# Copyright (C) 2007 Ilsoo Byun <widepis@etri.re.kr ,widepis@empal.com>
# 
# This program is being developed under the "OpenDRIM" project.
# The "OpenDRIM" project web page: http://opendrim.sourceforge.net
# The "OpenDRIM" project mailing list: opendrim@googlegroups.com
# 
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; version 2
# of the License.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
#################################################################################

#################################################################################
# To contributors, please leave your contact information in this section
# AND comment your changes in the source code.
# 
# Modified by 2008 Guillaume BOTTEX, ETRI <guillaumebottex@etri.re.kr, guillaumebottex@gmail.com>
###############################################################################*/

#include "cmpiOpenDRIM_IP2Gateway.h"

CMPIObjectPath* IP_OpenDRIM_IP2Gateway_toCMPIObjectPath(const CMPIBroker* broker, const OpenDRIM_IP2Gateway& instance) {
	_E_;
	Objectpath op(broker, OpenDRIM_IP2Gateway_classnames[0], OpenDRIM_IP2Gateway_NAMESPACE);

	if (!instance.Antecedent_isNULL)
		op.addKey("Antecedent", instance.Antecedent);

	if (!instance.Dependent_isNULL)
		op.addKey("Dependent", instance.Dependent);

	_L_;
	return op.getHdl();
}

CMPIInstance* IP_OpenDRIM_IP2Gateway_toCMPIInstance(const CMPIBroker* broker, const OpenDRIM_IP2Gateway& instance) {
	_E_;
	Objectpath op(broker, IP_OpenDRIM_IP2Gateway_toCMPIObjectPath(broker, instance));
	Instance ci(broker, op);

	if (!instance.IsDefault_isNULL)
		ci.setProperty("IsDefault", instance.IsDefault);

	if (!instance.OrderOfAccess_isNULL)
		ci.setProperty("OrderOfAccess", instance.OrderOfAccess);

	_L_;
	return ci.getHdl();
}

void IP_OpenDRIM_IP2Gateway_toCPP(const CMPIBroker* broker, const CMPIObjectPath* ref, OpenDRIM_IP2Gateway& instance) {
	_E_;
	Objectpath op(broker, (CMPIObjectPath*) ref);

	if (op.getKey("Antecedent", instance.Antecedent) == OK)
		instance.Antecedent_isNULL = false;

	if (op.getKey("Dependent", instance.Dependent) == OK)
		instance.Dependent_isNULL = false;

	_L_;
}

void IP_OpenDRIM_IP2Gateway_toCPP(const CMPIBroker* broker, const CMPIInstance* ci, OpenDRIM_IP2Gateway& instance) {
	_E_;
	Instance inst(broker, (CMPIInstance*) ci);

	if (inst.getProperty("Antecedent", instance.Antecedent) == OK)
		instance.Antecedent_isNULL = false;

	if (inst.getProperty("Dependent", instance.Dependent) == OK)
		instance.Dependent_isNULL = false;

	if (inst.getProperty("IsDefault", instance.IsDefault) == OK)
		instance.IsDefault_isNULL = false;

	if (inst.getProperty("OrderOfAccess", instance.OrderOfAccess) == OK)
		instance.OrderOfAccess_isNULL = false;

	_L_;
}

